GetRunWindowStyle Proc Private Uses Edi Esi lpWindowData:LPLONG, bWindow:BOOL
	Mov Esi, lpWindowData
	Xor Edi, Edi
	.If (DWord Ptr [Esi + pNormalStyle] & WS_BORDER)
		Or Edi, WS_BORDER
	.EndIf
	.If (DWord Ptr [Esi + pNormalStyle] & WS_DLGFRAME)
		Or Edi, WS_DLGFRAME
	.EndIf
	.If (DWord Ptr [Esi + pNormalStyle] & WS_CLIPCHILDREN)
		Or Edi, WS_CLIPCHILDREN
	.EndIf
	.If (DWord Ptr [Esi + pNormalStyle] & WS_CLIPSIBLINGS)
		Or Edi, WS_CLIPSIBLINGS
	.EndIf
	.If (DWord Ptr [Esi + pNormalStyle] & WS_SYSMENU)
		Or Edi, WS_SYSMENU
	.EndIf
	.If (DWord Ptr [Esi + pNormalStyle] & WS_MAXIMIZEBOX)
		Or Edi, WS_MAXIMIZEBOX
	.EndIf
	.If (DWord Ptr [Esi + pNormalStyle] & WS_MINIMIZEBOX)
		Or Edi, WS_MINIMIZEBOX
	.EndIf
	.If (DWord Ptr [Esi + pNormalStyle] & WS_HSCROLL)
		Or Edi, WS_HSCROLL
	.EndIf
	.If (DWord Ptr [Esi + pNormalStyle] & WS_VSCROLL)
		Or Edi, WS_VSCROLL
	.EndIf
	.If (DWord Ptr [Esi + pNormalStyle] & WS_THICKFRAME)
		Or Edi, WS_THICKFRAME
	.EndIf
	.If (DWord Ptr [Esi + pVisible])
		Or Edi, WS_VISIBLE
	.EndIf
	.If (!DWord Ptr [Esi + pEnabled])
		Or Edi, WS_DISABLED
	.EndIf
	.If (!bWindow)
		Or Edi, WS_CHILD
	.Else
		.If (DWord Ptr [Esi + pMDIChild] || DWord Ptr [Esi + pStyle] == eChild)
			Or Edi, WS_CHILD
		.ElseIf (DWord Ptr [Esi + pStyle] == ePopup)
			Or Edi, WS_POPUP
		.ElseIf (DWord Ptr [Esi + pStyle] == eOverlapped)
			Or Edi, WS_OVERLAPPED
		.EndIf
	.EndIf
	Invoke IsGreaterThan, DWord Ptr [Esi + pType], eModule
	Push Eax
	Invoke IsLessThan, DWord Ptr [Esi + pType], ecStatic
	Pop Edx
	.If ((Edx && Eax) || DWord Ptr [Esi + pType] == ecEdit || DWord Ptr [Esi + pType] == ecList || DWord Ptr [Esi + pType] == ecCombo || DWord Ptr [Esi + pType] == ecPicture || DWord Ptr [Esi + pType] == ecRichEdit)
		.If (DWord Ptr [Esi + pScrollBars] == eHorizontal)
			Or Edi, WS_HSCROLL
		.ElseIf (DWord Ptr [Esi + pScrollBars] == eVertical)
			Or Edi, WS_VSCROLL
		.ElseIf (DWord Ptr [Esi + pScrollBars] == eBoth)
			Or Edi, (WS_HSCROLL Or WS_VSCROLL)
		.EndIf
	.EndIf
	Invoke IsGreaterThan, DWord Ptr [Esi + pType], ecWindow
	.If (Eax)
		.If (DWord Ptr [Esi + pType] == ecStatic || DWord Ptr [Esi + pType] == ecImage)
			Or Edi, SS_NOTIFY
			.If (DWord Ptr [Esi + pTextAlign] == eTextAlignCenter)
				Or Edi, SS_CENTER
			.ElseIf (DWord Ptr [Esi + pTextAlign] == eTextAlignRight)
				Or Edi, SS_RIGHT
			.ElseIf (!DWord Ptr [Esi + pWordWrap])
				Or Edi, SS_LEFTNOWORDWRAP
			.EndIf
			.If (DWord Ptr [Esi + pCenterVertically])
				Or Edi, SS_CENTERIMAGE
			.EndIf
			.If (DWord Ptr [Esi + pNoPrefix])
				Or Edi, SS_NOPREFIX
			.EndIf
			.If (DWord Ptr [Esi + pPathEllipsis])
				Or Edi, SS_PATHELLIPSIS
			.EndIf
		.ElseIf (DWord Ptr [Esi + pType] == ecEdit || DWord Ptr [Esi + pType] == ecRichEdit)
			.If (DWord Ptr [Esi + pAutoHScroll])
				Or Edi, ES_AUTOHSCROLL
			.EndIf
			.If (DWord Ptr [Esi + pAutoVScroll])
				Or Edi, ES_AUTOVSCROLL
			.EndIf
			.If (DWord Ptr [Esi + pMultiLine])
				Or Edi, ES_MULTILINE
			.EndIf
			.If (DWord Ptr [Esi + pReadOnly])
				Or Edi, ES_READONLY
			.EndIf
			.If (DWord Ptr [Esi + pWantReturn])
				Or Edi, ES_WANTRETURN
			.EndIf
			.If (DWord Ptr [Esi + pTextAlign] == eTextAlignCenter)
				Or Edi, ES_CENTER
			.ElseIf (DWord Ptr [Esi + pTextAlign] == eTextAlignRight)
				Or Edi, ES_RIGHT
			.EndIf
			.If (DWord Ptr [Esi + pCaseStyle] == eLower)
				Or Edi, ES_LOWERCASE
			.ElseIf (DWord Ptr [Esi + pCaseStyle] == eUpper)
				Or Edi, ES_UPPERCASE
			.ElseIf (DWord Ptr [Esi + pCaseStyle] == eNumber)
				Or Edi, ES_NUMBER
			.EndIf
			.If (DWord Ptr [Esi + pType] == ecRichEdit)
				.If (DWord Ptr [Esi + pDisableNoScroll])
					Or Edi, ES_DISABLENOSCROLL
				.EndIf
				.If (DWord Ptr [Esi + pHideSelection] == 0)
					Or Edi, ES_NOHIDESEL
				.EndIf
			.EndIf
		.ElseIf (DWord Ptr [Esi + pType] == ecButton)
			.If DWord Ptr [Esi + pMultiLine]
				Or Edi, BS_MULTILINE
			.EndIf
			.If DWord Ptr [Esi + pOwnerDraw]
				Or Edi, BS_OWNERDRAW
			.EndIf
			.If (DWord Ptr [Esi + pNormalStyle] & BS_CENTER)
				Or Edi, BS_CENTER
			.EndIf
			Or Edi, BS_NOTIFY
		.ElseIf (DWord Ptr [Esi + pType] == ecCheck)
			Or Edi, BS_NOTIFY
			.If (DWord Ptr [Esi + pAuto])
				Or Edi, BS_AUTOCHECKBOX
			.Else
				Or Edi, BS_CHECKBOX
			.EndIf
			.If (DWord Ptr [Esi + pTextAlign] == eTextAlignCenter)
				Or Edi, BS_CENTER
			.ElseIf (DWord Ptr [Esi + pTextAlign] == eTextAlignRight)
				Or Edi, BS_RIGHT
			.EndIf
		.ElseIf (DWord Ptr [Esi + pType] == ecRadio)
			Or Edi, BS_NOTIFY
			.If (DWord Ptr [Esi + pAuto])
				Or Edi, BS_AUTORADIOBUTTON
			.Else
				Or Edi, BS_RADIOBUTTON
			.EndIf
			.If (DWord Ptr [Esi + pTextAlign] == eTextAlignCenter)
				Or Edi, BS_CENTER
			.ElseIf (DWord Ptr [Esi + pTextAlign] == eTextAlignRight)
				Or Edi, BS_RIGHT
			.EndIf
		.ElseIf (DWord Ptr [Esi + pType] == ecList)
			Or Edi, LBS_NOTIFY
			.If (!DWord Ptr [Esi + pIntegralHeight])
				Or Edi, LBS_NOINTEGRALHEIGHT
			.EndIf
			.If (DWord Ptr [Esi + pUseTabStops])
				Or Edi, LBS_USETABSTOPS
			.EndIf
			Or Edi, WS_VSCROLL
			.If (DWord Ptr [Esi + pSorted])
				Or Edi, LBS_SORT
			.EndIf
			.If (DWord Ptr [Esi + pMultiColumn])
				Or Edi, LBS_MULTICOLUMN
			.EndIf
			.If (DWord Ptr [Esi + pMultiSelect] == 1)
				Or Edi, LBS_EXTENDEDSEL
			.ElseIf (DWord Ptr [Esi + pMultiSelect] == 2)
				Or Edi, LBS_MULTIPLESEL
			.EndIf
			.If (DWord Ptr [Esi + pOwnerDraw] == 1)
				Or Edi, LBS_OWNERDRAWFIXED
			.ElseIf (DWord Ptr [Esi + pOwnerDraw] == 2)
				Or Edi, LBS_OWNERDRAWVARIABLE
			.EndIf
			Or Edi, LBS_HASSTRINGS
		.ElseIf (DWord Ptr [Esi + pType] == ecCombo)
			.If (!DWord Ptr [Esi + pIntegralHeight])
				Or Edi, CBS_NOINTEGRALHEIGHT
			.EndIf
			Or Edi, WS_VSCROLL
			.If (DWord Ptr [Esi + pSorted])
				Or Edi, CBS_SORT
			.EndIf
			.If (DWord Ptr [Esi + pCaseStyle] == eLower)
				Or Edi, CBS_LOWERCASE
			.ElseIf (DWord Ptr [Esi + pCaseStyle] == eUpper)
				Or Edi, CBS_UPPERCASE
			.EndIf
			.If (DWord Ptr [Esi + pStyle] == 0)
				Or Edi, CBS_DROPDOWN
			.ElseIf (DWord Ptr [Esi + pStyle] == 1)
				Or Edi, CBS_SIMPLE
			.ElseIf (DWord Ptr [Esi + pStyle] == 2)
				Or Edi, CBS_DROPDOWNLIST
			.EndIf
			.If (DWord Ptr [Esi + pOwnerDraw] == 1)
				Or Edi, CBS_OWNERDRAWFIXED
			.ElseIf (DWord Ptr [Esi + pOwnerDraw] == 2)
				Or Edi, CBS_OWNERDRAWVARIABLE
			.EndIf
			Or Edi, (CBS_AUTOHSCROLL Or CBS_HASSTRINGS)
		.ElseIf (DWord Ptr [Esi + pType] == ecHScroll)
			Or Edi, SBS_HORZ
		.ElseIf (DWord Ptr [Esi + pType] == ecVScroll)
			Or Edi, SBS_VERT
		.ElseIf (DWord Ptr [Esi + pType] == ecTreeView)
			.If (DWord Ptr [Esi + pCheckBoxes])
				Or Edi, TVS_CHECKBOXES
			.EndIf
			.If (DWord Ptr [Esi + pEditLabels])
				Or Edi, TVS_EDITLABELS
			.EndIf
			.If (DWord Ptr [Esi + pFullRowSelect])
				Or Edi, TVS_FULLROWSELECT
			.EndIf
			.If (DWord Ptr [Esi + pHasButtons])
				Or Edi, TVS_HASBUTTONS
			.EndIf
			.If (DWord Ptr [Esi + pHasLines])
				Or Edi, TVS_HASLINES
			.EndIf
			.If (!DWord Ptr [Esi + pHideSelection])
				Or Edi, TVS_SHOWSELALWAYS
			.EndIf
			.If (DWord Ptr [Esi + pLinesAtRoot])
				Or Edi, TVS_LINESATROOT
			.EndIf
			.If (DWord Ptr [Esi + pNoToolTips])
				Or Edi, TVS_NOTOOLTIPS
			.EndIf
			.If (DWord Ptr [Esi + pDisableDragDrop])
				Or Edi, TVS_DISABLEDRAGDROP
			.EndIf
		.ElseIf (DWord Ptr [Esi + pType] == ecListView)
			.If (DWord Ptr [Esi + pAlign] == 0)
				Or Edi, LVS_ALIGNTOP
			.ElseIf (DWord Ptr [Esi + pAlign] == 1)
				Or Edi, LVS_ALIGNLEFT
			.EndIf
			.If (DWord Ptr [Esi + pView] == eIcon)
				Or Edi, LVS_ICON
			.ElseIf (DWord Ptr [Esi + pView] == eSmallIcon)
				Or Edi, LVS_SMALLICON
			.ElseIf (DWord Ptr [Esi + pView] == eReport)
				Or Edi, LVS_REPORT
			.Else
				Or Edi, LVS_LIST
			.EndIf
			.If (DWord Ptr [Esi + pAutoArrange])
				Or Edi, LVS_AUTOARRANGE
			.EndIf
			.If (DWord Ptr [Esi + pEditLabels])
				Or Edi, LVS_EDITLABELS
			.EndIf
			.If (!DWord Ptr [Esi + pHideSelection])
				Or Edi, LVS_SHOWSELALWAYS
			.EndIf
			.If (DWord Ptr [Esi + pMultiSelect] == 0)
				Or Edi, LVS_SINGLESEL
			.EndIf
			.If (DWord Ptr [Esi + pNoColumnHeader])
				Or Edi, LVS_NOCOLUMNHEADER
			.EndIf
			.If (DWord Ptr [Esi + pNoLabelWrap])
				Or Edi, LVS_NOLABELWRAP
			.EndIf
			.If (DWord Ptr [Esi + pNoSortHeader])
				Or Edi, LVS_NOSORTHEADER
			.EndIf
		.ElseIf (DWord Ptr [Esi + pType] == ecToolBar || DWord Ptr [Esi + pType] == ecStatusBar)
			And Edi, 0FFFFF000H
			Mov Eax, DWord Ptr [Esi + pNormalStyle]
			And Eax, 0000FFFFH
			.If DWord Ptr [Esi + pType] == ecStatusBar
				And Eax, 00000FFFH
			.EndIf
			Or Edi, Eax
		.ElseIf (DWord Ptr [Esi + pType] == ecProgressBar)
			.If (DWord Ptr [Esi + pOrientation] != 0)
				Or Edi, PBS_VERTICAL
			.EndIf
			.If (DWord Ptr [Esi + pScrolling] != 0)
				Or Edi, PBS_SMOOTH
			.EndIf
		.ElseIf (DWord Ptr [Esi + pType] == ecSlider)
			Or Edi, TBS_AUTOTICKS
			.If (DWord Ptr [Esi + pOrientation] != 0)
				Or Edi, TBS_VERT
			.EndIf
			.If (DWord Ptr [Esi + pSelectRange])
				Or Edi, TBS_ENABLESELRANGE
			.EndIf
			.If (DWord Ptr [Esi + pTickStyle] == 1)
				Or Edi, TBS_BOTTOM
			.ElseIf (DWord Ptr [Esi + pTickStyle] == 2)
				Or Edi, TBS_TOP
			.ElseIf (DWord Ptr [Esi + pTickStyle] == 3)
				Or Edi, TBS_BOTH
			.Else
				Or Edi, (TBS_NOTICKS Or TBS_BOTH)
			.EndIf
		.ElseIf (DWord Ptr [Esi + pType] == ecTabStrip)
			.If (DWord Ptr [Esi + pMultiLine])
				Or Edi, TCS_MULTILINE
			.EndIf
			.If (DWord Ptr [Esi + pOwnerDraw])
				Or Edi, TCS_OWNERDRAWFIXED
			.EndIf
			.If (DWord Ptr [Esi + pStyle])
				Or Edi, TCS_BUTTONS
				.If DWord Ptr [Esi + pStyle] == 2
					Or Edi, TCS_FLATBUTTONS
				.EndIf
			.EndIf
			.If (DWord Ptr [Esi + pPlacement] == 1)
				Or Edi, TCS_BOTTOM
			.ElseIf (DWord Ptr [Esi + pPlacement] == 2)
				Or Edi, TCS_VERTICAL
			.ElseIf (DWord Ptr [Esi + pPlacement] == 3)
				Or Edi, (TCS_RIGHT Or TCS_VERTICAL)
			.EndIf
			.If (DWord Ptr [Esi + pTabWidthStyle] == 1)
				Or Edi, TCS_RAGGEDRIGHT
			.ElseIf (DWord Ptr [Esi + pTabWidthStyle] == 2)
				Or Edi, TCS_FIXEDWIDTH
			.Else
				Or Edi, TCS_RIGHTJUSTIFY
			.EndIf
		.ElseIf (DWord Ptr [Esi + pType] == ecUpDown)
			.If (DWord Ptr [Esi + pAlignment] == 1)
				Or Edi, UDS_ALIGNLEFT
			.ElseIf (DWord Ptr [Esi + pAlignment] == 2)
				Or Edi, UDS_ALIGNRIGHT
			.EndIf
			.If (DWord Ptr [Esi + pArrowKeys])
				Or Edi, UDS_ARROWKEYS
			.EndIf
			.If (DWord Ptr [Esi + pAutoBuddy])
				Or Edi, UDS_AUTOBUDDY
			.EndIf
			.If (DWord Ptr [Esi + pHotTrack])
				Or Edi, UDS_HOTTRACK
			.EndIf
			.If (DWord Ptr [Esi + pNoThousands])
				Or Edi, UDS_NOTHOUSANDS
			.EndIf
			.If (DWord Ptr [Esi + pOrientation] == 0)
				Or Edi, UDS_HORZ
			.EndIf
			.If (DWord Ptr [Esi + pSetBuddyInt])
				Or Edi, UDS_SETBUDDYINT
			.EndIf
			.If (DWord Ptr [Esi + pWrap])
				Or Edi, UDS_WRAP
			.EndIf
		.ElseIf (DWord Ptr [Esi + pType] == ecAnimate)
			.If (DWord Ptr [Esi + pAutoPlay])
				Or Edi, ACS_AUTOPLAY
			.EndIf
			.If (DWord Ptr [Esi + pCenter])
				Or Edi, ACS_CENTER
			.EndIf
			.If (DWord Ptr [Esi + pTransparent])
				Or Edi, ACS_TRANSPARENT
			.EndIf
		.ElseIf (DWord Ptr [Esi + pType] == ecImageCombo)
			.If (DWord Ptr [Esi + pStyle] == 0)
				Or Edi, CBS_DROPDOWN
			.ElseIf (DWord Ptr [Esi + pStyle] == 1)
				Or Edi, CBS_SIMPLE
			.ElseIf (DWord Ptr [Esi + pStyle] == 2)
				Or Edi, CBS_DROPDOWNLIST
			.EndIf
			Or Edi, WS_VSCROLL
		.ElseIf (DWord Ptr [Esi + pType] == ecCalendar)
			.If (DWord Ptr [Esi + pDayStates])
				Or Edi, MCS_DAYSTATE
			.EndIf
			.If (DWord Ptr [Esi + pMultiSelect])
				Or Edi, MCS_MULTISELECT
			.EndIf
			.If (DWord Ptr [Esi + pNoToday])
				Or Edi, MCS_NOTODAY
			.EndIf
			.If (DWord Ptr [Esi + pWeekNumbers])
				Or Edi, MCS_WEEKNUMBERS
			.EndIf
		.ElseIf (DWord Ptr [Esi + pType] == ecDateTime)
			.If (DWord Ptr [Esi + pAllowEdit])
				Or Edi, DTS_APPCANPARSE
			.EndIf
			.If (DWord Ptr [Esi + pRightAlign])
				Or Edi, DTS_RIGHTALIGN
			.EndIf
			.If (DWord Ptr [Esi + pShowNone])
				Or Edi, DTS_SHOWNONE
			.EndIf
			.If (DWord Ptr [Esi + pStyle] == 1)
				Or Edi, DTS_LONGDATEFORMAT
			.ElseIf (DWord Ptr [Esi + pStyle] == 2)
				Or Edi, DTS_TIMEFORMAT
			.EndIf
		.ElseIf (DWord Ptr [Esi + pType] == ecPager)
			.If (DWord Ptr [Esi + pAutoScroll])
				Or Edi, PGS_AUTOSCROLL
			.EndIf
			.If (DWord Ptr [Esi + pDragAndDrop])
				Or Edi, PGS_DRAGNDROP
			.EndIf
			.If (DWord Ptr [Esi + pOrientation] == 0)
				Or Edi, PGS_HORZ
			.EndIf
		.ElseIf (DWord Ptr [Esi + pType] == ecHeader)
			.If (DWord Ptr [Esi + pDragAndDrop])
				Or Edi, HDS_DRAGDROP
			.EndIf
			.If (DWord Ptr [Esi + pFullDrag])
				Or Edi, HDS_FULLDRAG
			.EndIf
			.If (DWord Ptr [Esi + pHasButtons])
				Or Edi, HDS_BUTTONS
			.EndIf
			.If (DWord Ptr [Esi + pHidden])
				Or Edi, HDS_HIDDEN
			.EndIf
			.If (DWord Ptr [Esi + pHotTrack])
				Or Edi, HDS_HOTTRACK
			.EndIf
		.ElseIf (DWord Ptr [Esi + pType] == ecRebar)
			Or Edi, (CCS_NOPARENTALIGN Or CCS_ADJUSTABLE Or CCS_NORESIZE)
			.If (DWord Ptr [Esi + pAutoSize])
				Or Edi, RBS_AUTOSIZE
			.EndIf
			.If (DWord Ptr [Esi + pBandBorders])
				Or Edi, RBS_BANDBORDERS
			.EndIf
			.If (DWord Ptr [Esi + pDblClkToggle])
				Or Edi, RBS_DBLCLKTOGGLE
			.EndIf
			.If (DWord Ptr [Esi + pFixedOrder])
				Or Edi, RBS_FIXEDORDER
			.EndIf
			.If (DWord Ptr [Esi + pVarHeight])
				Or Edi, RBS_VARHEIGHT
			.EndIf
			.If (DWord Ptr [Esi + pAlign] == ecPicAlignLeft || DWord Ptr [Esi + pAlign] == ecPicAlignRight)
				Or Edi, CCS_VERT
			.EndIf
		.EndIf
	.EndIf
	Return Edi
GetRunWindowStyle EndP
